package com.fp.frontend.controller.armas.solicitud;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.parmas.soli.TarmInspeccion;
import com.fp.persistence.parmas.soli.TarmInspeccionArchivo;

/**
 * Clase controladora del bean TgeneCatalogDetail.
 *
 * @author C.P.
 * @version 2.1
 */
@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class InspeccionArchivoController extends AbstractController<TarmInspeccionArchivo> {

    public InspeccionArchivoController() throws Exception {
        super(TarmInspeccionArchivo.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 15; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "INSPECCIONARCHIVO";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Crea una instancia de TgeneTransactionProcess y marca el registro como
     * nuevo.
     *
     * @throws Exception
     */
    @Override
    public void create() throws Exception {
        super.create();
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.cinspeccion");

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            Request request = this.callerhelper.getRequest();
            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TarmInspeccionArchivo>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TarmInspeccionArchivo>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los registros nuevos.
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = this.callerhelper.getRequest();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    /**
     * Metodo para encontrar por codigo de inspeccion
     *
     * @param codigoSolicitud
     * @return registro de archivo inspeccion encontrado
     */
    public static List<TarmInspeccionArchivo> findPorInspeccion(String codigoInspeccion) {
        try {
            InspeccionArchivoController cc = new InspeccionArchivoController();
            cc.init();
            cc.recperpage = 300;
            cc.addFilter("cinspeccion", codigoInspeccion);
            cc.querydatabase();
            if (cc.lrecord != null) {
                return cc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

    /**
     * Metodo que encuentra los archivos de inspeccion por codigo de solicitud
     *
     * @param codigoSolicitud
     * @return una lista de archivos que cumplen todos los criterios de busqueda
     */
    public static List<TarmInspeccionArchivo> findPorSolicitud(String codigoSolicitud) {
        try {
            List<TarmInspeccion> lInspeccion = InspeccionController.findPorSolicitud(codigoSolicitud);
            List<TarmInspeccionArchivo> lInspeccionArchivo = new ArrayList<>();
            for (TarmInspeccion inspeccion : lInspeccion) {
                List<TarmInspeccionArchivo> lInspeccionesArchivoEncontradas = findPorInspeccion(String.valueOf(inspeccion.getPk()));
                if (lInspeccionesArchivoEncontradas != null && !lInspeccionesArchivoEncontradas.isEmpty()) {
                    lInspeccionArchivo.addAll(lInspeccionesArchivoEncontradas);
                }
            }
            return lInspeccionArchivo;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }
    }

}
